#include Automatic.lua

function init()
    GroundDetection = 0.025
    TimingError = 0.25
    JumpError = 0.4
    CancelSpeedThreshold = 1 
    
    Drag = 32
    ScrollVelocity = 150
    MovementSpeed = 24
    
    activated = false
    timesincegrounded = 0
    timegrounded = 0
    timesincejumprel = 0

    landingposition = GetPlayerTransform().pos
    
    wobblesnd = LoadLoop('snd/Wobble.ogg', 1.5)
    wobblesndvol = 1
    activatesnd = LoadSound('snd/Activate.ogg', 1.5)
    activatesndvol = 0.45

    spr = LoadSprite('spr/circ.png')
end

function tick(dt)
    local P = GetPlayerTransform(true)
    P.nopitch = GetPlayerTransform(false)
    P.vel = GetPlayerVelocity()
    local C = GetCameraTransform()
    C.vel = TransformToParentPoint(C, P.vel)

    local hit, dist = QueryRaycast(P.pos, Vec(0, -1, 0), GroundDetection, 0.1)
    timesincegrounded = hit and 0 or (timesincegrounded + dt)
    timesincejumprel = InputReleased('jump') and 0 or (timesincejumprel + dt)

    local invehicle = GetPlayerVehicle() ~= 0

    if invehicle and activated then activated = false PlaySound(activatesnd, P.pos, activatesndvol) end

    if not invehicle then
        if activated then
            local dragdelta = dt * Drag
            local pvelscale = math.max(VecLength(P.vel) - dragdelta, 0)
            local Velocity = AutoVecRescale(P.vel, pvelscale)

            if InputDown('shift') then
                SetBool('game.input.locktool', true)
                Velocity[2] = Velocity[2] + InputValue('mousewheel') * ScrollVelocity * dt
            end

            local mv = GetMovementVector()
            local relativemv = TransformToParentVec(P.nopitch, Vec(mv.x, 0, -mv.y))
            Velocity = VecAdd(Velocity, VecScale(relativemv, (Drag + MovementSpeed) * dt))

            SetPlayerVelocity(Velocity)

            if VecLength(P.vel) < CancelSpeedThreshold and hit then
                activated = false
                PlaySound(activatesnd, P.pos, activatesndvol)
            else
                if InputPressed('jump') then
                    activated = false
                    PlaySound(activatesnd, P.pos, activatesndvol)
                end
            end

            wobblesndvol = AutoClamp(AutoMap(VecLength(P.vel), 0, 64, 0, 0.1), 0, 0.2)
            PlayLoop(wobblesnd, C.pos, wobblesndvol)

            -- local predict, predictvel, predictnorm = AutoPredictPlayerPosition(2, true)
            -- local drop = predict[#predict]
            -- DrawSprite(spr, Transform(drop, QuatEuler(-90, 0, 0)), 0.75, 0.75, 1, 1, 1, 1, false, true)
            -- DebugLine(drop, VecAdd(drop, predictnorm))
        else
            if InputPressed('jump') and not hit and ((timesincegrounded > TimingError) or (timesincejumprel < JumpError)) then
                activated = true
                PlaySound(activatesnd, P.pos, activatesndvol)
            end
        end
    end
    
    SetBool('game.warpdrive', activated)
end

function update(dt)
    if activated then
        local Velocity = GetPlayerVelocity()
        Velocity[2] = Velocity[2] + 10 * dt
        SetPlayerVelocity(Velocity)
    end
end

function GetMovementVector()
    local v = {x = 0, y = 0}
    v.x = v.x + (InputDown('right') and 1 or 0)
    v.x = v.x + (InputDown('left') and -1 or 0)
    v.y = v.y + (InputDown('up') and 1 or 0)
    v.y = v.y + (InputDown('down') and -1 or 0)
    return v
end


function draw(dt)

end